using Dapfor.Net.Formats;
using Dapfor.Net.Ui;

namespace Dapfor.Net.Demo.Examples.DataBinding.Populating
{
    /// <summary>
    /// The objects of this class will be shown on the top hierarchical level of the <see cref="Grid"/>
    /// </summary>
    public class RootClass
    {
        //Some enumeration

        #region EnumExample enum

        public enum EnumExample
        {
            Internal,
            External,
        }

        #endregion

        #region Fields

        private readonly EnumExample _orderType;
        private double _doubleValue;
        private int _intValue;
        private string _stringValue;

        #endregion

        public RootClass(double doubleValue, int intValue, string stringValue, EnumExample orderType)
        {
            _doubleValue = doubleValue;
            _intValue = intValue;
            _stringValue = stringValue;
            _orderType = orderType;
        }

        #region Public properties

        public string Name
        {
            get { return _stringValue; }
            set { _stringValue = value; }
        }

        public int Count
        {
            get { return _intValue; }
            set { _intValue = value; }
        }

        [Format("0.000")]
        public double Price
        {
            get { return _doubleValue; }
            set { _doubleValue = value; }
        }

        public EnumExample OrderType
        {
            get { return _orderType; }
        }

        #endregion
    }
}