using System;
using Dapfor.Net.Data;
using Dapfor.Net.Formats;

namespace Dapfor.Net.Demo.Examples.Miscellaneous.FileExplorer
{
    //Demonstrates the custom formatting (file size formatting)
    public class SizeCustomFormat : IFormat
    {
        #region IFormat Members

        public string Format(IDataField dataField)
        {
            decimal value = Convert.ToDecimal(dataField.Value);
            value = Decimal.Ceiling(value/1024);

            return value != 0 ? string.Format("{0:n0} Ko", value) : string.Empty;
        }

        public bool CanParse(string text, IDataField dataField)
        {
            return false;
        }

        public void Parse(string text, IDataField dataField)
        {
        }

        #endregion
    }
}