using System;
using System.ComponentModel;
using Dapfor.Net.Data;
using Dapfor.Net.Ui;

namespace Dapfor.Net.Demo.Examples.Performance.RealtimeSort
{
    /// <summary>
    /// The objects of this class will be inserted into the <see cref="Grid"/>. When a field of this object is changed, 
    /// it notifies <see cref="Grid"/> via the <see cref="INotifyPropertyChanged"/> interface. If nofifications
    /// come from non-GUI thread, the <see cref="Grid"/> will synchronize threads itself.
    /// </summary>
    public class DataObject : INotifyPropertyChanged, IGetAccelerator
    {
        #region Fields 

        private int value0;
        private int value1;
        private int value2;
        private int value3;
        private int value4;
        private int value5;
        private int value6;
        private int value7;
        private int value8;
        private int value9;

        #endregion

        public DataObject(Random r)
        {
            if (r != null)
            {
                value0 = r.Next() % 1200;
                value1 = r.Next() % 1200;
                value2 = r.Next() % 1200;
                value3 = r.Next() % 1200;
                value4 = r.Next() % 1200;
                value5 = r.Next() % 1200;
                value6 = r.Next() % 1200;
                value7 = r.Next() % 1200;
                value8 = r.Next() % 1200;
                value9 = r.Next() % 1200;
            }
        }


        #region Public properties

        [Field("Id0")]
        public int Value0
        {
            get { return value0; }
            set
            {
                value0 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id0"));
                }
            }
        }

        [Field("Id1")]
        public int Value1
        {
            get { return value1; }
            set
            {
                value1 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id1"));
                }
            }
        }

        [Field("Id2")]
        public int Value2
        {
            get { return value2; }
            set
            {
                value2 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id2"));
                }
            }
        }

        [Field("Id3")]
        public int Value3
        {
            get { return value3; }
            set
            {
                value3 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id3"));
                }
            }
        }

        [Field("Id4")]
        public int Value4
        {
            get { return value4; }
            set
            {
                value4 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id4"));
                }
            }
        }

        [Field("Id5")]
        public int Value5
        {
            get { return value5; }
            set
            {
                value5 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id5"));
                }
            }
        }

        [Field("Id6")]
        public int Value6
        {
            get { return value6; }
            set
            {
                value6 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id6"));
                }
            }
        }

        [Field("Id7")]
        public int Value7
        {
            get { return value7; }
            set
            {
                value7 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id7"));
                }
            }
        }

        [Field("Id8")]
        public int Value8
        {
            get { return value8; }
            set
            {
                value8 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id8"));
                }
            }
        }

        [Field("Id9")]
        public int Value9
        {
            get { return value9; }
            set
            {
                value9 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id9"));
                }
            }
        }

        #endregion

        #region IGetAccelerator Members

        public IGetter GetGetter(IDataField field)
        {
            //This method accelerates the values getting. If our case, the DataObject implements the 
            //IGetAccelerator interface and the Grid will try to get values by calling this method 
            //instead of using the reflection mechanism. 
            //ValueGetter - just a container for values, returned by Value0..Value9 properties

            switch (field.Id)
            {
                case "Id0":
                    return new ValueGetter(Value0);
                case "Id1":
                    return new ValueGetter(Value1);
                case "Id2":
                    return new ValueGetter(Value2);
                case "Id3":
                    return new ValueGetter(Value3);
                case "Id4":
                    return new ValueGetter(Value4);
                case "Id5":
                    return new ValueGetter(Value5);
                case "Id6":
                    return new ValueGetter(Value6);
                case "Id7":
                    return new ValueGetter(Value7);
                case "Id8":
                    return new ValueGetter(Value8);
                case "Id9":
                    return new ValueGetter(Value9);
            }
            return null;
        }

        #endregion

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion
    }
}