using System;
using System.Windows.Forms;

namespace Dapfor.Net.Demo.Internal
{
    public partial class FormExampleHolder : Form
    {
        private Control _currentControl;

        public FormExampleHolder()
        {
            InitializeComponent();
        }

        public void SetControl(Type controlType)
        {
            SuspendLayout();
            if (_currentControl != null)
            {
                Controls.Remove(_currentControl);
                _currentControl.Dispose();
                _currentControl = null;
            }
            if (controlType != null)
            {
                _currentControl = (Control)Activator.CreateInstance(controlType);
                foreach (Control control in _currentControl.Controls)
                {
                    if(control is ExampleDescription)
                    {
                        control.Visible = false;
                        break;
                    }
                }

                _currentControl.Visible = false;
                _currentControl.Size = ClientRectangle.Size;
                _currentControl.SuspendLayout();
                Controls.Add(_currentControl);
                _currentControl.Dock = DockStyle.Fill;
                _currentControl.ResumeLayout();
                _currentControl.Visible = true;
            }
            ResumeLayout(true);
        }
    }
}